// zad1.c
// prevodjenje: gcc -o prog zad1.c  -pthread
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>
#include <time.h>
// otkomentarisati za sleep ili usleep
//#include <unistd.h>

// deljeni podaci za niti A i B
int x, y, z;
sem_t semXY;
sem_t semZ;

// potpis funkcije niti je uvek void* (f*)(void*)
void* a(void* param){
     int i = 0;
     srand(time(0));
     while(1){
         x = rand()%10;
         y = rand()%10;
         // signal semXY
         sem_post(&semXY);
         // wait semZ
         sem_wait(&semZ);
         // uspavljivanje tekuce niti, u sekundama
         // sleep(1);
         printf("%d + %d = %d\n", x, y, z);
         if(++i == 10) break;
     }
     printf("a() - finished\n");
     return 0;
}

void* b(void* param){
    int i = 0;
    while(1){
        // wait semXY
        sem_wait(&semXY);
        z = x + y;
        // semZ signal
        sem_post(&semZ);
        if(++i == 10){
            break;
        }
     }
     printf("b() - finished\n");
     return 0;
}

int main(int argc, char* argv[]){
     pthread_t nitA, nitB;
     // pravljenje semafora, inicijalizacija na 0
     if(sem_init(&semXY, 0, 0) || sem_init(&semZ, 0, 0)){ 
          perror(NULL); exit(1);
     }
     // pravljenje niti
     if(pthread_create(&nitA, 0, a, 0) || pthread_create(&nitB, 0, b, 0)){
          perror(NULL); exit(1);
     }
     // main nit ceka da niti A i B zavrse
     // (u slucaju da vise niti radi join za istu nit, ponasanje je nedefinisano)
     pthread_join(nitA, 0);
     pthread_join(nitB, 0);
     // obavezno unistavanje semafora
     // (u slucaju da je neka nit blokirana na semaforu, ponasanje je nedefinisano)
     sem_destroy(&semXY);
     sem_destroy(&semZ);
     printf("main() - finished\n");
     return 0;
}
