// zad1_verzija2.c
// prevodjenje: gcc -o prog zad1.c –pthread
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>
#include <time.h>
// otkomentarisati za sleep ili usleep
//#include <unistd.h>

// definisana je nova struktura podataka
typedef struct shared_data{
       int x, y, z;
       sem_t semXY;
       sem_t semZ;
}  shared_data;

// potpis funkcije niti je uvek void* (f*)(void*)
void* a(void* param){
       shared_data* data = (shared_data*)param;
       int i = 0;
       srand(time(0));
       while(1){
            data->x = rand()%10;
            data->y = rand()%10;
            // signal semXY
            sem_post(&(data->semXY));
            // wait semZ
            sem_wait(&(data->semZ));
            // uspavljivanje tekuce niti, u sekundama
            // sleep(1);
            printf("%d + %d = %d\n", data->x, data->y, data->z);
            if(++i == 10){
                    break;
            }
       }
       printf("a() - finished\n");
       return 0;
}

void* b(void* param){
      shared_data* data = (shared_data*)param;
      int i = 0;
      while(1){   
          // wait semXY
          sem_wait(&(data->semXY));
          data->z = data->x + data->y;
          // semZ signal
          sem_post(&(data->semZ));
          if(++i == 10){
             break;
          }
       }
       printf("b() - finished\n");
       return 0;
}

int main(int argc, char* argv[]){
       shared_data data;
       pthread_t nitA, nitB;
       // pravljenje semafora, inicijalizacija na 0
       if(sem_init(&data.semXY, 0, 0) || sem_init(&data.semZ, 0, 0)){ 
          perror(NULL); exit(1);
       }
       // pravljenje niti
       if(pthread_create(&nitA, 0, a, &data) || pthread_create(&nitB, 0, b, &data)){
          perror(NULL); exit(1);
       }
       // main nit ceka da niti A i B zavrse
       // (u slucaju da vise niti radi join za istu nit, ponasanje ne nedefinisano)
       pthread_join(nitA, 0);
       pthread_join(nitA, 0);
       // unistavanje semafora
       // (u slucaju da je neka nit blokirana na semaforu, ponasanje je nedefinisano)
       sem_destroy(&(data.semXY));
       sem_destroy(&(data.semZ));
       printf("main() - finished\n");
       return 0;
}

