// za vezbu dodati petlje nitima x, y, z i p!

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
// #include <unistd.h>
#include <time.h>

#define THREAD_CNT 4

typedef struct shared_data{
	int a, b, c;
	sem_t* sem;
} shared_data;

void* p(void* params){
	shared_data* data = (shared_data*)params;
	sem_wait(data->sem);
	sem_wait(data->sem);
	sem_wait(data->sem);
	int res = data->a + data->b + data->c;
	printf("%d + %d + %d = %d\n", data->a, data->b, data->c, res);
	return 0;
}

void* x(void* params){
	shared_data* data = (shared_data*)params;
	// sleep(1);
	data->a = rand()%10;
	sem_post(data->sem);
	return 0;
}

void* y(void* params){
	shared_data* data = (shared_data*)params;
	data->b = rand()%10;
	sem_post(data->sem);
	return 0;
}

void* z(void* params){
	shared_data* data = (shared_data*)params;
	// sleep(2);
	data->c = rand()%10;
	sem_post(data->sem);
	return 0;
}

typedef void* (*threadFunc)(void*);

int main(int argc, char* argv[]){
	// podaci koji ce biti deljeni medju nitima p, x, y i z
	shared_data data;
	// obavezno alociranje prostora za polje tipa sem_t*
	data.sem = (sem_t*)malloc(sizeof(sem_t));
	// niz koji ce sadrzati identifikatore niti p, x, y i z
	pthread_t threads[THREAD_CNT];
	// niz koji sadrzi adrese funkcija nad kojima ce se redom izvrsavati niti p, x, y i z
	threadFunc funcs[THREAD_CNT] = {p, x, y, z};
	// promenljiva za iteriranje kroz prethodne nizove
	int i;
	// postavljanje slucajnog semena rand funkciji
	srand(time(0));
	// inicijalizacija semafora koji ce koristiti niti p, x, y i z
	sem_init(data.sem, 0, 0);
	// kreiranje niti p, x, y i z nad odgovarajucim funkcijama koje ce sve imati parametar data
	for(i=0; i<THREAD_CNT; i++){
		pthread_create(&(threads[i]), 0, funcs[i], &data);
	}
	// main nit ceka da sva deca zavrse
	for(i=0; i<THREAD_CNT; i++){
		pthread_join(threads[i], 0);
	}
	// unistavanje semafora
	sem_destroy(data.sem);
	// dealociranje dinamicki zauzetog prostora
	free(data.sem);
	return 0;
}
