//////////////////////////////////////////////////////////////////////////////
// u ovoj verziji niti x, y i z imaju istu funkciju nad kojom se izvrsavaju //
//////////////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <stdio.h>

#include <pthread.h>
#include <semaphore.h>
//#include <unistd.h>
#include <time.h>

#define THREAD_CNT 4

typedef struct shared_data{
	int a, b, c;
	sem_t* sem;
} shared_data;

// dodata je nova struktura xyz_data za niti x, y i z
typedef struct xyz_data{
	shared_data* data;
	int offset;		// offset kaze da li se pristupa polju a, b ili c u podatku data
} xyz_data;

void* p(void* params){
	shared_data* data = (shared_data*)params;
	sem_wait(data->sem);
	sem_wait(data->sem);
	sem_wait(data->sem);
	int res = data->a + data->b + data->c;
	printf("%d + %d + %d = %d\n", data->a, data->b, data->c, res);
	return 0;
}

/*
void* x(void* params){
	shared_data* data = (shared_data*)params;
	// sleep(1);
	data->a = rand()%10;
	sem_post(data->sem);
	return 0;
}

void* y(void* params){
	shared_data* data = (shared_data*)params;
	data->b = rand()%10;
	sem_post(data->sem);
	return 0;
}

void* z(void* params){
	shared_data* data = (shared_data*)params;
	// sleep(2);
	data->c = rand()%10;
	sem_post(data->sem);
	return 0;
}
*/

// jedna funkcija za sve tri niti - x, y i z
void* xyz(void* params){
	// sleep(1);
	xyz_data* thData = (xyz_data*)params;
	*((int*)(thData->data) + (thData->offset)) = rand()%10;
	sem_post(thData->data->sem);
	return 0;
}

typedef void* (*threadFunc)(void*);

int main(int argc, char* argv[]){
	// podaci koji ce biti deljeni medju nitima p, x, y i z
	shared_data data;
	// obavezno alociranje prostora za polje tipa sem_t*
	data.sem = (sem_t*)malloc(sizeof(sem_t));
	// niz koji ce sadrzati identifikatore niti p, x, y i z	
	pthread_t threads[THREAD_CNT];
	// promenljiva za iteriranje kroz prethodne nizove
	int i;
	// postavljanje slucajnog semena rand funkciji
	srand(time(0));
	// inicijalizacija semafora koji ce koristiti niti p, x, y i z
	sem_init(data.sem, 0, 0);
	// niz koji sadrzi parametre za niti x, y i z
	xyz_data thData[THREAD_CNT-1];

	// kreiranje niti x, y i z nad odgovarajucim funkcijama koje ce sve imati parametar tipa xyz_data
	for(i=0; i<THREAD_CNT-1; i++){
		thData[i].data = &data;
		thData[i].offset = i;
		pthread_create(&threads[i], 0, xyz, thData+i);
	}
	// poslednja nit je nit p, koja ce imati parametar tipa shared_data
	pthread_create(&threads[i], 0, p, &data);

	// main nit ceka da sva deca zavrse
	for(i=0; i<THREAD_CNT; i++){
		pthread_join(threads[i], 0);
	}
	// unistavanje semafora
	sem_destroy(data.sem);
	// dealociranje dinamicki zauzetog prostora
	free(data.sem);

	return 0;
}
