// zad3.c
// prevodjenje: gcc -o prog zad3.c -pthread

#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>
#include <semaphore.h>

typedef struct sharedData
{
	int a[2];
	int i;
	sem_t readyToRead;
	sem_t readyToWrite;
	sem_t mutex;
} sharedData;

typedef void* (*threadFunc)(void*);

#define THREAD_CNT 3

void* xy(void* args){
	sharedData* data = (sharedData*)args;
	int iter = 10;
	int i;
	while(iter-- > 0){
		sem_wait(&data->readyToWrite);
		sem_wait(&data->mutex);
		i = data->i;
		data->a[i] = rand()%10;
		data->i = (i+1)%2;
		sem_post(&data->mutex);
		sem_post(&data->readyToRead);
	}
	return NULL;
}

void* z(void* args){
	sharedData* data = (sharedData*)args;
	int iter = 10;
	int res;
	while(iter-- > 0){
		sem_wait(&data->readyToRead);
		sem_wait(&data->readyToRead);
		res = data->a[0] + data->a[1];
		printf("%d + %d = %d\n", data->a[0], data->a[1], res);
		sem_post(&data->readyToWrite);
		sem_post(&data->readyToWrite);
	}
	return 0;
}

int main(int argc, char* argv[]){
	sharedData data;
	data.i = 0;
	sem_init(&data.readyToRead, 0, 0);		// readyToRead inicijalizovan na 0
	sem_init(&data.readyToWrite, 0, 2);		// readyToWrite inicijalizovan na 2
	sem_init(&data.mutex, 0, 1);			// mutex inicijalizovan na 0

	pthread_t threads[THREAD_CNT];
	threadFunc funcs[THREAD_CNT] = {xy, xy, z};
	int i;

	srand(time(0));

	for(i=0; i<THREAD_CNT; i++){
		pthread_create(&threads[i], 0, funcs[i], &data);
	}

	for(i=0; i<THREAD_CNT; i++){
		pthread_join(threads[i], 0);
	}

	// unistavanje semafora
	sem_destroy(&data.readyToRead);
	sem_destroy(&data.readyToWrite);
	sem_destroy(&data.mutex);

	printf("%s\n", "Happy ending!\n");

	return 0;

}
