// zad4.c
// prevodjenje: gcc -o prog zad4.c –pthread

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>
#include <time.h>

#define THREAD_CNT 10
#define MAX_ITERATIONS 50
#define MICROSECONDS 1000

typedef struct shared_data {
  sem_t semA, semB, semC;
} shared_data;

typedef struct thread_data{
  int thread_id;
  shared_data *data;
} thread_data;

void* p(void* args){
  thread_data *t_data = (thread_data*)args;
  shared_data *s_data = t_data->data;
  int thread_id = t_data->thread_id;
  int counter = 0;
  
  while(counter++ < MAX_ITERATIONS){
    // sekcija A
    sem_wait(&s_data->semA);
    printf("Section A - thread %d\n", thread_id);
    usleep(rand()%1000 * MICROSECONDS);
      // sekcija B
      sem_wait(&s_data->semB);
      printf("Section B - thread %d\n", thread_id);
      usleep(rand()%1000 * MICROSECONDS);
      sem_post(&s_data->semB);
      // sekcija C
      sem_wait(&s_data->semC);
      printf("Section C - thread %d\n", thread_id);
      usleep(rand()%1000 * MICROSECONDS);
      sem_post(&s_data->semC);
    sem_post(&s_data->semA);
  }
  return NULL;
}

int main(int argc, char* argv[]){
  shared_data s_data;
  thread_data t_data[THREAD_CNT];
  pthread_t threads[THREAD_CNT];
  int i;

  sem_init(&s_data.semA, 0, THREAD_CNT);
  sem_init(&s_data.semB, 0, 1);
  sem_init(&s_data.semC, 0, 1);
  
  srand(time(0));
  for(i=0; i<THREAD_CNT; i++){
    t_data[i].data = &s_data;
    t_data[i].thread_id = i;
    pthread_create(&threads[i], 0, p, &t_data[i]);
  }

  for(i=0; i<THREAD_CNT; i++){
    pthread_join(threads[i], 0);
  }

  sem_destroy(&s_data.semA);
  sem_destroy(&s_data.semB);
  sem_destroy(&s_data.semC);

  printf("%s\n", "Happy ending!\n");

  return 0;

}
